import { html, ref, repeat, when } from '@microsoft/fast-element';
export const menuTemplate = html `
  <fast-button
    id="actiosnMenuTrigger"
    class="actions-opener${(x) => (x.open ? ' opened' : '')}"
    appearance="${(x) => x.buttonAppearance}"
    part="actions-opener"
    @click=${(x) => x.toggleActionsMenuVisibility()}
  >
    ${(x) => x.open
    ? '✖'
    : html `
            ${x.name}
          `}
  </fast-button>
  <fast-menu ${ref('actionsMenu')} class="actions-menu ${(x) => x.classNames}" part="actions-menu">
    ${repeat((x) => x.allActions, html `
        ${when((x, context) => x.isDisabled && x.isDisabled(context.parent.rowData), html `
            <fast-menu-item
              class="menu-item"
              tabindex="${(x, context) => context.index}"
              disabled
              style=${(x, ctx) => (ctx.parent.hideDisabled ? 'display:none' : '')}
            >
              ${(x, ctx) => ctx.parent.getLabel(x.name)}
            </fast-menu-item>
          `)}
        ${when((x, context) => !x.isDisabled || !x.isDisabled(context.parent.rowData), html `
            <fast-menu-item
              class="menu-item"
              tabindex="${(x, context) => context.index}"
              @click=${(x, context) => context.parent.onActionMenuItemClick(x.callback)}
              style="${(x) => (x.color ? `color: ${x.color};` : '')}"
            >
              ${(x, ctx) => ctx.parent.getLabel(x.name)}
            </fast-menu-item>
          `)}
      `, { positioning: true })}
  </fast-menu>
`;
export const singleOptionTemplate = html `
  <fast-button
    appearance="${(x) => x.buttonAppearance}"
    part="actions-opener"
    class="actions-opener"
    @click=${(x) => {
    return x === null || x === void 0 ? void 0 : x.singleOption.callback(x.rowData);
}}
    ?disabled=${(x) => {
    return (x === null || x === void 0 ? void 0 : x.singleOption.isDisabled) && (x === null || x === void 0 ? void 0 : x.singleOption.isDisabled(x.rowData));
}}
  >
    ${(x) => x.getLabel(x === null || x === void 0 ? void 0 : x.singleOption.name)}
  </fast-button>
`;
export const foundationActionsMenuTemplate = html `
  <div
    class="actions-container${(x) => (x.isVertical ? ' actions-vertical' : '')}"
    part="actions-container"
  >
    ${(x) => x.getTemplate()}
  </div>
`;
